#include <iostream>

using namespace std;

class MyArray {
public:
    MyArray() {
        dat = NULL;
        len = 0;
    }

    MyArray(int d[], int num); //normal

    MyArray(const MyArray &rhs); //copy constructor

    MyArray &operator=(const MyArray &rhs); // copy assignment operator

    void set(int loc, int val) { dat[loc] = val; }

    int &operator[](int loc) { return dat[loc]; }

    int const &operator[](int loc) const { return dat[loc]; }

    int size() const { return len; }

private:
    int len;
    int *dat;

};

// Normal constructor
MyArray::MyArray(int d[], int num) {
    dat = new int[num];
    len = num;
    for (int i = 0; i < len; i++) {
        dat[i] = d[i];
    }
}

// copy constructor
MyArray::MyArray(const MyArray &rhs) {
   {
       len = rhs.len;
       dat = new int[len];
       for (int i = 0; i < len; i++) {
           dat[i] = rhs.dat[i];
       }
   }
}

// copy assignment operator
MyArray &MyArray::operator=(const MyArray &rhs) {
   {
       if (this == &rhs) { // self-assignment may lead to memory leak
           return *this;
       }
       if (dat) { // dest. object may already be initialized and overwriting data members may lead to a memory leak
           delete dat;
       }
       len = rhs.len;
       dat = new int[len];
       for (int i = 0; i < len; i++) {
           dat[i] = rhs.dat[i];
       }
   }
   return *this;
}

void printVals(MyArray arr) {
    for (int i = 0; i < arr.size(); i++) {
        cout << arr[i] << " ";
    }
    cout << endl;
}

int main() {
    int vals[] = {9, 3, 7, 5};
    MyArray a1(vals, 4);
    MyArray a2(a1); // calls default copy
    MyArray a3 = a1; // calls default copy
    MyArray a4;
    a4 = a1; // calls default assignment
    // how are the contents of a2, a3, a4
    // related to a1

    cout << "a1[0]: " << a1[0] << endl;
    cout << "a2[0]: " << a2[0] << endl;
    cout << "a3[0]: " << a3[0] << endl;
    cout << "a4[0]: " << a4[0] << endl;
    cout << endl;
    a1.set(0, 2);
    cout << "a1[0]: " << a1[0] << endl;
    cout << "a2[0]: " << a2[0] << endl;
    cout << "a3[0]: " << a3[0] << endl;
    cout << "a4[0]: " << a4[0] << endl;

    return 0;
}
